#pragma once

#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <cstdlib>
#include <string>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <gl\glut.h>
#include <math.h>
#include "vector.h"
#include "particles.h"
#include "pilot.h"

using namespace std;
using namespace System::Windows::Forms;

#define GROUND 10

GLuint		texture[3];							// Storage For One Texture 
Vec	terrain[GROUND][GROUND];
Vec	pilot_vel;
Pilot bobafett;
int mouse_state;
PartSystem exhaust;

namespace OpenGLForm 
{

	public ref class COpenGL: public System::Windows::Forms::NativeWindow
	{
		//MAIN INITIALIZE
	public:
		COpenGL(System::Windows::Forms::Form ^ parentForm, GLsizei iWidth, GLsizei iHeight)
		{
			CreateParams^ cp = gcnew CreateParams;

			// Set the position on the form
			cp->X = 10;
			cp->Y = 10;
			cp->Height = iHeight;
			cp->Width = iWidth;

			// Specify the form as the parent.
			cp->Parent = parentForm->Handle;

			// Create as a child of the specified parent and make OpenGL compliant (no clipping)
			cp->Style = WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

			// Create the actual window
			this->CreateHandle(cp);

			m_hDC = GetDC((HWND)this->Handle.ToPointer());

			//glutKeyboardFunc(processNormalKeys);
			//glutMouseFunc(mouse);
			//here we are calling our new funtion


			//Initialize cylinder terrain and vectors
			int i, j;
			for(j = 0; j<GROUND; j++) {
				for(i = 0; i<GROUND; i++) {
					terrain[i][j].InitDir();
				}
			}

			if(m_hDC)
			{
				MySetPixelFormat(m_hDC);
				ReSizeGLScene(iWidth, iHeight);
				InitGL();
			}

			//Initialize globals
			bobafett.InitPilot();
			exhaust.InitSys(0, bobafett.GetLocation());
		}

		//OPENGL INITIALIZE
		bool InitGL(GLvoid)										// All setup for opengl goes here
		{
			GLfloat initx, inity, initz;


			glShadeModel(GL_SMOOTH);							// Enable smooth shading
			glClearColor(0.0f, 0.8f, 1.0f, 1.0f);				// Black background
			glClearDepth(1.0f);									// Depth buffer setup
			glEnable(GL_DEPTH_TEST);							// Enables depth testing
			glDepthFunc(GL_LEQUAL);								// The type of depth testing to do
			glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really nice perspective calculations

			glLoadIdentity();

			if (!NeHeLoadBitmap("resources/grass.bmp", texture[0]))					// Load The Bitmap
				return FALSE;													// Return False If Loading Failed
			if (!NeHeLoadBitmap("resources/dirt.bmp", texture[1]))					// Load The Bitmap
				return FALSE;													// Return False If Loading Failed
						if (!NeHeLoadBitmap("resources/particle.bmp", texture[2]))					// Load The Bitmap
				return FALSE;													// Return False If Loading Failed
			glEnable( GL_LIGHTING );

			glEnable(GL_TEXTURE_2D);
			glPushMatrix();	
			int a, b;
			int zed = 0;
			GLfloat radius = 2.0f;
			GLfloat pi = 2.0f * 3.14159f;

		
			for(a = 0; a<GROUND; a++) {
								initx = a*10.0f;
				for(b = 0; b<GROUND; b++) {
	
					inity = 0.0f;
					initz = b*10.0f;
					terrain[a][b].SetVel(initx,inity,initz);
				}
			}

			

			glPopMatrix();
			// lighting stuff
			GLfloat ambient[] = {0.3, 0.3, 0.3, 1.0};
			GLfloat diffuse[] = {0.9, 0.9, 0.9, 1.0};
			GLfloat specular[] = {0.4, 0.4, 0.4, 1.0};
			GLfloat position[] = {5.0, 5.0, 0.0, 1.0};

			glPushMatrix();

			glLightfv( GL_LIGHT0, GL_POSITION, position );
			glLightfv( GL_LIGHT0, GL_AMBIENT, ambient );
			glLightfv( GL_LIGHT0, GL_DIFFUSE, diffuse );
			glLightfv( GL_LIGHT0, GL_SPECULAR, specular );
			glEnable( GL_COLOR_MATERIAL );
			float mcolor[] = { 1.0f, 1.0f, 1.0f, 1.0f };
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mcolor);

			glEnable( GL_LIGHT0 );
			glPopMatrix();
			return TRUE;										// Initialisation went ok
		}

		//MAIN DRAW METHOD
		System::Void Render(System::Void)
		{
						Vec camcoor;
						Vec temp;

			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear screen and depth buffer
			glLoadIdentity();									// Reset the current modelview matrix
			glBindTexture(GL_TEXTURE_2D, texture[0]);				// Select Our Texture
		
			camcoor = bobafett.GetLocation();
			gluLookAt(camcoor.GetX(),camcoor.GetY()+9.0f,camcoor.GetZ()+7.0f,camcoor.GetX()+1.0f,camcoor.GetY()+4.0f,camcoor.GetZ()+1.0f,0.0f,1.0f,0.0f);

			glPushMatrix();
	
			glPopMatrix();
			glEnable(GL_TEXTURE_2D);
			glColor3f(0.0f,1.0f,0.0f);
			glPushMatrix();
	
			glPopMatrix();
			DrawTerrain();
	Keyboard_Input(); 
			bobafett.MoveAround();

			glPushMatrix();

		
			bobafett.DrawPilot();

			glPopMatrix();

			exhaust.RunSys();

			exhaust.SetOrigin(bobafett.GetLocation());
		}

		//DRAW GROUND
		void DrawTerrain() 
		{
					int i, j, k;
					float norm;
norm = 0.0f;
			for(j = 0; j<GROUND-1; j++) {
				glBegin(GL_TRIANGLE_STRIP);
				for(i = 0; i<GROUND; i++) {
					glTexCoord2f((i%5)/4.0f, (j%5)/4.0f);
					glNormal3f(0.0f,1.0f,0.0f);
					glVertex3f(terrain[i][j].GetX(),0.0f,terrain[i][j].GetZ());

					glTexCoord2f((i%5)/4.0f, ((j+1)%5)/4.0f);
					glNormal3f(0.0f,1.0f,0.0f);
					glVertex3f(terrain[i][j+1].GetX(),0.0f,terrain[i][j+1].GetZ());
				}
				glEnd();
			}

			for(j = 0; j<GROUND; j++) {
				glBegin(GL_TRIANGLE_STRIP);
				for(i = 0; i<GROUND; i++) {
					glTexCoord2f((i%5)/4.0f, (j%5)/4.0f);
					glNormal3f(1.0f,0.0f,0.0f);
					glVertex3f(terrain[i][0].GetX(),norm,terrain[i][0].GetZ());


					glTexCoord2f((i%5)/4.0f, ((j+1)%5)/4.0f);
					glNormal3f(1.0f,0.0f,0.0f);
					glVertex3f(terrain[i][0].GetX(),norm-10.0f,terrain[i][0].GetZ());
				}
	
				glEnd();

				glBegin(GL_TRIANGLE_STRIP);
				for(i = 0; i<GROUND; i++) {
					glTexCoord2f((i%5)/4.0f, (j%5)/4.0f);
					glNormal3f(0.0f,0.0f,1.0f);
					glVertex3f(terrain[0][i].GetX(),norm,terrain[0][i].GetZ());

					glTexCoord2f((i%5)/4.0f, ((j+1)%5)/4.0f);
					glNormal3f(0.0f,0.0f,1.0f);
					glVertex3f(terrain[0][i].GetX(),norm-10.0f,terrain[0][i].GetZ());
				}
				
				glEnd();
				
				glBegin(GL_TRIANGLE_STRIP);
				for(i = 0; i<GROUND; i++) {
					glTexCoord2f((i%5)/4.0f, (j%5)/4.0f);
					glNormal3f(0.0f,0.0f,1.0f);
					glVertex3f(terrain[GROUND-1][i].GetX(),norm,terrain[GROUND-1][i].GetZ());

					glTexCoord2f((i%5)/4.0f, ((j+1)%5)/4.0f);
					glNormal3f(0.0f,0.0f,1.0f);
					glVertex3f(terrain[GROUND-1][i].GetX(),norm-10.0f,terrain[GROUND-1][i].GetZ());
				}
				
				glEnd();

								glBegin(GL_TRIANGLE_STRIP);
				for(i = 0; i<GROUND; i++) {
					glTexCoord2f((i%5)/4.0f, (j%5)/4.0f);
					glNormal3f(0.0f,0.0f,1.0f);
					glVertex3f(terrain[i][GROUND-1].GetX(),norm,terrain[i][GROUND-1].GetZ());

					glTexCoord2f((i%5)/4.0f, ((j+1)%5)/4.0f);
					glNormal3f(0.0f,0.0f,1.0f);
					glVertex3f(terrain[i][GROUND-1].GetX(),norm-10.0f,terrain[i][GROUND-1].GetZ());
				}
				
				glEnd();

				norm -= 10.0f;
			}
		}

		//VARIABLES
	private:
		HDC m_hDC;
		HGLRC m_hglrc;


		//DESTRUCTOR
	public:
		~COpenGL(System::Void)
		{
			this->DestroyHandle();
		}

		//PIXEL FORMATTING
		GLint MySetPixelFormat(HDC hdc)
		{
			static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
			{
				sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
				1,											// Version Number
				PFD_DRAW_TO_WINDOW |						// Format Must Support Window
				PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
				PFD_DOUBLEBUFFER,							// Must Support Double Buffering
				PFD_TYPE_RGBA,								// Request An RGBA Format
				16,										// Select Our Color Depth
				0, 0, 0, 0, 0, 0,							// Color Bits Ignored
				0,											// No Alpha Buffer
				0,											// Shift Bit Ignored
				0,											// No Accumulation Buffer
				0, 0, 0, 0,									// Accumulation Bits Ignored
				16,											// 16Bit Z-Buffer (Depth Buffer)  
				0,											// No Stencil Buffer
				0,											// No Auxiliary Buffer
				PFD_MAIN_PLANE,								// Main Drawing Layer
				0,											// Reserved
				0, 0, 0										// Layer Masks Ignored
			};

			GLint  iPixelFormat; 

			// get the device context's best, available pixel format match 
			if((iPixelFormat = ChoosePixelFormat(hdc, &pfd)) == 0)
			{
				MessageBox::Show("ChoosePixelFormat Failed");
				return 0;
			}

			// make that match the device context's current pixel format 
			if(SetPixelFormat(hdc, iPixelFormat, &pfd) == FALSE)
			{
				MessageBox::Show("SetPixelFormat Failed");
				return 0;
			}

			if((m_hglrc = wglCreateContext(m_hDC)) == NULL)
			{
				MessageBox::Show("wglCreateContext Failed");
				return 0;
			}

			if((wglMakeCurrent(m_hDC, m_hglrc)) == NULL)
			{
				MessageBox::Show("wglMakeCurrent Failed");
				return 0;
			}

			return 1;
		}

		//BMP IMAGE LOADER
		bool NeHeLoadBitmap(LPTSTR szFileName, GLuint &texid)					// Creates Texture From A Bitmap File
		{
			HBITMAP hBMP;														// Handle Of The Bitmap
			BITMAP	BMP;														// Bitmap Structure

			glGenTextures(1, &texid);											// Create The Texture
			hBMP=(HBITMAP)LoadImage(GetModuleHandle(NULL), szFileName, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE );

			if (!hBMP)															// Does The Bitmap Exist?
				return FALSE;													// If Not Return False

			GetObject(hBMP, sizeof(BMP), &BMP);									// Get The Object
			// hBMP:        Handle To Graphics Object
			// sizeof(BMP): Size Of Buffer For Object Information
			// &BMP:        Buffer For Object Information

			glPixelStorei(GL_UNPACK_ALIGNMENT, 4);								// Pixel Storage Mode (Word Alignment / 4 Bytes)

			// Typical Texture Generation Using Data From The Bitmap
			glBindTexture(GL_TEXTURE_2D, texid);								// Bind To The Texture ID
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);	// Linear Min Filter
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	// Linear Mag Filter
			glTexImage2D(GL_TEXTURE_2D, 0, 3, BMP.bmWidth, BMP.bmHeight, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE, BMP.bmBits);

			DeleteObject(hBMP);													// Delete The Object

			return TRUE;														// Loading Was Successful
		}



		//RESIZE SCENE
		GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize and initialise the gl window
		{
			if (height==0)										// Prevent A Divide By Zero By
			{
				height=1;										// Making Height Equal One
			}

			glViewport(0,0,width,height);						// Reset The Current Viewport

			glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
			glLoadIdentity();									// Reset The Projection Matrix

			// Calculate The Aspect Ratio Of The Window
			gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,1000.0f);

			glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
			glLoadIdentity();									// Reset The Modelview Matrix

		}

		//GET SLIDER VALUES
		void getSliders(int frequency, int amplitude) {
	
		}		
		
		//TOGGLE WIREFRAME
		void showWires(bool isWireframe) {
			if (isWireframe)
				glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
			else
				glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		}

		//SWAP BUFFERS
		System::Void SwapOpenGLBuffers(System::Void)
		{
			SwapBuffers(m_hDC) ;
		}

		void Keyboard_Input()
		{
			if(GetAsyncKeyState(0x4A))
			{
				bobafett.FlyUp(1);
			}
			else 
				bobafett.FlyUp(0);

						if(GetAsyncKeyState(0x44)) {
				bobafett.FlyHorizontal(1); //0=no, 1=x, 2=-x, 3=no, 4=z, 5=-z
			}
						else if(GetAsyncKeyState(0x41)) {
							bobafett.FlyHorizontal(2);
						}
			else 
				bobafett.FlyHorizontal(0);

					if(GetAsyncKeyState(0x57)) {
				bobafett.FlyHorizontal(5); //0=no, 1=x, 2=-x, 3=no, 4=z, 5=-z
			}
						else if(GetAsyncKeyState(0x53)) {
							bobafett.FlyHorizontal(4);
						}
			else 
				bobafett.FlyHorizontal(3);
		}

	};
}