#ifndef _BOID_H
#define _BOID_H

#include <ostream>
#include "point.h"
#include "vector.h"

#define TAIL 6

//BOID CLASS
class Boid
{

	//VARIABLES
private:
	Point chain[TAIL];
	Vec velocity;
	int stateflag;

	//CONSTRUCTORS
public:
	void InitBoid() 
	{
		int i;
		for(i = 0; i<TAIL; i++) {
			chain[i].InitPos();
		}
		velocity = Vec();
		stateflag = 0;
	}

	//MANIPULATION METHODS
	void SetBoidPos(int i, float x, float y) 
	{
		chain[i].SetPos(x, y);
	}

	void SetWholePos(float x, float y)
	{
		int i;
		for(i = 0; i<TAIL; i++) {
			chain[i].SetPos(x,y);
		}
	}

	void SetBoidVel(float x, float y)
	{
		velocity.SetVel(x,y);
	}

	void UpdateState(int i)
	{
		stateflag = i;
	}

	void Scooch() 
	{
		int i;

		for(i = TAIL-1; i>0; i--) {
			chain[i] = chain[i-1];
		}
	}

	//ACCESS METHODS
	Point GetPos(int i) 
	{
		return chain[i];
	}

	Vec GetVec() 
	{
		return velocity;
	}
	
	int GetState() 
	{
		return stateflag;
	}

};


#endif 