#ifndef _PARTICLES_H
#define _PARTICLES_H

#include <iostream>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <ctime>
#include <stdio.h>
#include "vector.h"

#define MAX_PARTICLES 100

class Particle {
private:
Vec velocity; //Position of the particle
Vec location; //Velocity of the particle
int age; //Current age of the particle
int life; //Age after which the particle dies
Vec color; //X=red, Y=green, Z=blue
float size;

public:
	void CreateParticle(int a, Vec x) 
	{
		float i,j,k;

		srand(time(NULL));
		if(a==0) {					//fire
			life = (rand()%50)/8;
			color.SetVel(1.0f,0.95f,0.8f);
		}
		else {						//smoke
			life = (rand()%250)/10;
			color.SetVel(0.6f,0.6f,0.6f);
		}			
		i = (float)rand()/(float)RAND_MAX;
			j = (float)rand()/(float)RAND_MAX;
			k = (float)rand()/(float)RAND_MAX;

			velocity.SetVel(i/10.0f,-j*2.0f,k/10.0f);
		location = x;
		age = 0;
		size = 0.25f;

	}

void IncAge()
{
	age = age++;
}

	void SetLife(float x)
	{
		life = x;
	}

	void SetPosition(Vec x)
	{
		location = x;
	}

	void SetColor(float r, float g, float b)
	{
		color.SetVel(r,g,b);
	}

	void UpdateSize(float x)
	{
		size = x;
	}

	Vec GetPos() 
	{
		return location;
	}

	Vec GetVel()
	{
		return velocity;
	}

	int GetAge()
	{
		return age;
	}

	int GetLife()
	{
		return life;
	}

	float GetSize()
	{
		return size;
	}

	Vec GetColor()
	{
		return color;
	}

	void UpdatePart()
	{
		age++;
		if(age >= life) {
			age = 0;
		}

	}

};

class PartSystem
{
private:
	int part_type;
	Vec origin_point;
	Vec global_force;
	Vec force;
	Particle particles[MAX_PARTICLES];

public:
	void InitSys(int a, Vec x)
	{
		int i;

		part_type = a;
		global_force.InitDir();
		force.InitDir();
		origin_point = x;
		for(i = 0; i<MAX_PARTICLES; i++) {
			particles[i].CreateParticle(a, origin_point);
		}
	}

	void RunSys()
	{
		int i;
		Vec move;
		Vec move2;
		Vec total;

		for(i = 0; i<MAX_PARTICLES; i++) {
			move = particles[i].GetPos();
			move2 = particles[i].GetVel();
			total.SetVel(move.GetX() + move2.GetX(),move.GetY() + move2.GetY() + 2.0f,move.GetZ() + move2.GetZ());
			particles[i].SetPosition(total);
			particles[i].IncAge();	
			
			if(particles[i].GetAge() >particles[i].GetLife()) {
				particles[i].CreateParticle(part_type, origin_point);
			}
		}



		for(i = 0; i<MAX_PARTICLES; i++) {
			move = particles[i].GetPos();
		glColor3f(1.0f,0.7f,0.0f);
		glBegin(GL_TRIANGLES);
		glVertex3f(move.GetX(), move.GetY(), move.GetZ());
		glVertex3f(move.GetX(), move.GetY(), move.GetZ());
		glVertex3f(move.GetX(), move.GetY(), move.GetZ());
		glEnd();
		}

	}

	void SetType(int a)
	{
		part_type = a;
	}

	void SetForce(Vec a)
	{
		global_force.SetVel(a.GetX(), a.GetY(), a.GetZ());
	}

	void SetOrigin(Vec a)
	{
			origin_point.SetVel(a.GetX(), a.GetY(), a.GetZ());
	}

	Particle GetParticle(int i)
	{
		return particles[i];
	}

	int GetType()
	{
		return part_type;
	}

	Vec GetForce()
	{
		return global_force;
	}

	Vec GetOrigin()
	{
		return origin_point;
	}


};

#endif