#ifndef _PILOT_H
#define _PILOT_H

#define GRAVITY -0.02f

class Pilot {
private:
	Vec trajectory;
	Vec location;
	int state;

public: 
	void InitPilot()
	{
		location.SetVel(50.0f,0.0f,50.0f);
		trajectory.SetVel(0.0f,0.0f,0.0f);
		state = 0;
	}

	void SetPosition(float x, float y, float z)
	{
		location.SetVel(x,y,z);
	}

	Vec GetLocation()
	{
		return location;
	}

	Vec GetTrajectory()
	{
		return trajectory;
	}

	void FlyUp(int a)
	{
		float x,y,z;

		x = trajectory.GetX();
		y = trajectory.GetY();
		z = trajectory.GetZ();

		if(a==1) {
	y += 0.015f;
	//y = y*1.5f;
		}
		else {
			y += GRAVITY;
		if(y<-1.5f)
			y = -1.5f;
		}
		trajectory.SetVel(x,y,z);
	}

	void FlyHorizontal(int a)
	{
		float x,y,z;

		x = trajectory.GetX();
		y = trajectory.GetY();
		z = trajectory.GetZ();

		if(a==0) 
			x = x*0.95f;

		else if(a == 1)
			x += 0.01f;

		else if(a == 2)
			x -= 0.01f;

		else if(a==3) 
			z = z*0.95f;

		else if(a == 4)
			z += 0.01f;

		else if(a == 5)
			z -= 0.01f;

				if(location.GetY() <0.1f) {
			if(location.GetX() < 82.0f && location.GetX() > -2.0f)  {
x = 0.0f;
			}
			if(location.GetZ() <92.0f && location.GetZ() > -2.0f) {
				z = 0.0f;
			}
		}

		trajectory.SetVel(x,y,z);
	}

	void MoveAround()
	{
		float x,y,z;

		x = location.GetX() + trajectory.GetX();
		
		z = location.GetZ() + trajectory.GetZ();
		if(location.GetY()>20.0f) {
			trajectory.SetVel(trajectory.GetX(),trajectory.GetY()-0.02f,trajectory.GetZ());
		}
	
y = location.GetY() + trajectory.GetY();

		if(y<0.1f) {
			if(x < 80.0f && x > 0.0f && z <90.0f && z > 0.0f)  {
y = 0.0f;
		}
		}
		location.SetVel(x,y,z);

	}

	void DrawPilot() {
		glColor3f(1.0f,0.0f,0.0f);
		glBegin(GL_QUAD_STRIP);

		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(location.GetX(),location.GetY(),location.GetZ());
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(location.GetX(),location.GetY()+5.0f,location.GetZ());
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY(),location.GetZ());
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY()+5.0f,location.GetZ());

		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY(),location.GetZ()-2.0f);
		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY()+5.0f,location.GetZ()-2.0f);

		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(location.GetX(),location.GetY(),location.GetZ()-2.0f);
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(location.GetX(),location.GetY()+5.0f,location.GetZ()-2.0f);

		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(location.GetX(),location.GetY(),location.GetZ());
		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(location.GetX(),location.GetY()+5.0f,location.GetZ());

		glEnd();

		glTranslatef(0.0f,2.0f,0.0f);
		glColor3f(0.6f,0.6f,0.6f);
		glBegin(GL_QUAD_STRIP);

		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY(),location.GetZ());
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY()+2.0f,location.GetZ());

		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY(),location.GetZ()+1.0f);
		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(location.GetX()+2.0f,location.GetY()+2.0f,location.GetZ()+1.0f);

		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(location.GetX(),location.GetY(),location.GetZ()+1.0f);
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(location.GetX(),location.GetY()+2.0f,location.GetZ()+1.0f);

		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(location.GetX(),location.GetY(),location.GetZ());
		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(location.GetX(),location.GetY()+2.0f,location.GetZ());

		glEnd();

	}

};

#endif